package betterwithmods.module.hardcore.needs;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.BlockDirtSlab;
import betterwithmods.module.Feature;
import betterwithmods.util.player.PlayerHelper;
import com.google.common.collect.Maps;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.ai.attributes.IAttributeInstance;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.MathHelper;
import net.minecraftforge.client.event.FOVUpdateEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import java.util.HashMap;
import java.util.UUID;


public class HCMovement extends Feature {
    public final static UUID PENALTY_SPEED_UUID = UUID.fromString("aece6a05-d163-4871-aaf3-ebab43b0fcfa");

    public static final HashMap<Material, Float> MATERIAL_MOVEMENT = Maps.newHashMap();
    public static final HashMap<IBlockState, Float> BLOCK_OVERRIDE_MOVEMENT = Maps.newHashMap();
    public static final float DEFAULT_SPEED = 0.75f;

    @Override
    public String getFeatureDescription() {
        return "Change walking speed depending on the block";
    }

    @Override
    public void preInit(FMLPreInitializationEvent event) {
        MATERIAL_MOVEMENT.put(Material.field_151576_e, 1.5f);
        MATERIAL_MOVEMENT.put(Material.field_151575_d, 1.5f);
        MATERIAL_MOVEMENT.put(Material.field_151573_f, 1.5f);
        MATERIAL_MOVEMENT.put(Material.field_151580_n, 1.5f);
        MATERIAL_MOVEMENT.put(Material.field_151593_r, 1.5f);
        MATERIAL_MOVEMENT.put(Material.field_151594_q, 1.5f);

        MATERIAL_MOVEMENT.put(Material.field_151577_b, 1.0f);
        MATERIAL_MOVEMENT.put(Material.field_151592_s, 1.0f);
        MATERIAL_MOVEMENT.put(Material.field_151578_c, 1.0f);
        MATERIAL_MOVEMENT.put(Material.field_151571_B, 1.0f);

        MATERIAL_MOVEMENT.put(Material.field_151595_p, 0.75f);
        MATERIAL_MOVEMENT.put(Material.field_151597_y, 0.75f);
        MATERIAL_MOVEMENT.put(Material.field_151584_j, 0.70f);
        MATERIAL_MOVEMENT.put(Material.field_151585_k, 0.70f);
        MATERIAL_MOVEMENT.put(Material.field_151582_l, 0.70f);

        BLOCK_OVERRIDE_MOVEMENT.put(Blocks.field_150425_aM.func_176223_P(),  0.70f);
        BLOCK_OVERRIDE_MOVEMENT.put(Blocks.field_150351_n.func_176223_P(), 1.5f);
        BLOCK_OVERRIDE_MOVEMENT.put(Blocks.field_185774_da.func_176223_P(), 1.5f);
        BLOCK_OVERRIDE_MOVEMENT.put(BWMBlocks.DIRT_SLAB.func_176223_P().func_177226_a(BlockDirtSlab.VARIANT, BlockDirtSlab.DirtSlabType.PATH), 1.5f);
    }


    @SubscribeEvent
    public void onWalk(TickEvent.PlayerTickEvent event) {
        if (event.phase == TickEvent.Phase.END) {
            EntityPlayer player = event.player;
            if (player.field_70122_E) {
                BlockPos blockpos = new BlockPos(MathHelper.func_76128_c(player.field_70165_t), MathHelper.func_76128_c(player.field_70163_u - 0.2D), MathHelper.func_76128_c(player.field_70161_v));
                IBlockState state = player.field_70170_p.func_180495_p(blockpos);
                float speed;
                if (BLOCK_OVERRIDE_MOVEMENT.containsKey(state)) {
                    speed = BLOCK_OVERRIDE_MOVEMENT.get(state);
                } else {
                    speed = MATERIAL_MOVEMENT.getOrDefault(state.func_185904_a(), DEFAULT_SPEED);
                }
                if (!player.field_70170_p.func_180495_p(player.func_180425_c()).func_185904_a().func_76220_a()) {
                    state = player.field_70170_p.func_180495_p(player.func_180425_c());
                    if (BLOCK_OVERRIDE_MOVEMENT.containsKey(state)) {
                        speed = BLOCK_OVERRIDE_MOVEMENT.get(state);
                    } else if (MATERIAL_MOVEMENT.containsKey(state.func_185904_a())) {
                        speed *= MATERIAL_MOVEMENT.get(state.func_185904_a());
                    }
                }
                PlayerHelper.changeSpeed(player, "HCMovement", speed, PENALTY_SPEED_UUID);
            }
        }
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }


	@SideOnly(Side.CLIENT)
    @SubscribeEvent
	public void onFOV(FOVUpdateEvent event) {
		float f = event.getFov();

		IAttributeInstance iattributeinstance = event.getEntity().func_110148_a(SharedMonsterAttributes.field_111263_d);

		double value = iattributeinstance.func_111126_e();
		if (iattributeinstance.func_111127_a(HCMovement.PENALTY_SPEED_UUID) != null) {
			value /= (1 + iattributeinstance.func_111127_a(HCMovement.PENALTY_SPEED_UUID).func_111164_d());
		}
		f = (float) ((double) f * ((value / (double) event.getEntity().field_71075_bZ.func_75094_b() + 1.0D) / 2.0D));

		event.setNewfov(f);
	}
}
